#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>

#define type_elem int
//si type_elem est modifié, affiche_elem doit être adaptée

void affiche_elem(type_elem elem);

struct s_cellule{
	type_elem val; //valeur de l'élément
	struct s_cellule* next; //adresse de la cellule suivante
	//ou NULL si c'est la dernière cellule de la liste
};

typedef struct s_cellule cellule;
typedef cellule* liste_c;


// fonctions de création et de suppression/libération
cellule* create_cell(type_elem elem);
liste_c create_from_tab(type_elem* tab, int lg);
void free_liste_c(liste_c l);

// fonction d'accès
void affiche_liste(liste_c l);
int nb_elem(liste_c l);
bool contient_elem(type_elem x, liste_c l);

// fonctions de modification
void ajoute_elem_debut(type_elem x, liste_c* ptr_l);

